#import "../aw.h"

@implementation Win : NSWindow
-(id) initFormWithTitle:(NSString*)title width:(NSInteger)width height:(NSInteger)height
{
  self = [super initWithContentRect: NSMakeRect(0, 0, width, height)
                styleMask: (NSTitledWindowMask | NSClosableWindowMask)
                backing: NSBackingStoreBuffered
                defer: NO];
  if (self) {          
    [self setTitle: title];
    [self center];
    [self makeKeyAndOrderFront:nil];
  }
  return self;
}


- (void)applicationDidFinishLaunching: (NSNotification *)notification
{
      [self orderFront: self];
}
 
- (BOOL)applicationShouldTerminateAfterLastWindowClosed: (NSNotification *)notification
{
      return YES;
}
- (void) GetFileName: (id) sender {
  // [txtFld setStringValue: [NSString stringWithUTF8String: OpenDialog()]]; 
    OpenDialog();
}
@end

id Window(const char* title, int w, int h) {
    id widget = [ [ NSWindow alloc ] initWithContentRect:NSMakeRect( 0, 0, w, h )
                       styleMask: NSClosableWindowMask | NSTitledWindowMask
                       backing:NSBackingStoreBuffered
                       defer:NO];
    [widget center];
    [widget setTitle: [NSString stringWithUTF8String:title] ];
    [widget makeKeyAndOrderFront:nil];
    return widget;
}

id newWindow(const char* title, int width, int height) {
    return [[[Win alloc] initFormWithTitle:[NSString stringWithUTF8String:title] width: width height: height] autorelease];
}
void SetText(id widget, const char* txt){
    if ( [widget isKindOfClass: [NSTextView class]] ) {
        [widget insertText: [NSString stringWithUTF8String:txt]];
        
    }else if ( [widget isKindOfClass: [NSTextField class]] )  {  
        [widget setStringValue:[NSString stringWithUTF8String:txt]];
    }
}

void AddItem(id widget, const char* txt ){
    [widget addItemWithObjectValue:[NSString stringWithUTF8String:txt]];
}

void Cocoa_Init() {
    [NSApplication sharedApplication];
    [NSApp setActivationPolicy:NSApplicationActivationPolicyRegular];
}

void Cocoa_Run(id mainWin) {
    [NSApp setDelegate:mainWin]; 
    [NSApp run];    
}